;------------------------------------------------------------------------
;
; 38kHzŕ`go͂邾̃vO
;
;------------------------------------------------------------------------
	errorlevel	-205			; Suppress message 205
	errorlevel	-207			; Suppress message 207
	errorlevel	-302			; Suppress message 302
	errorlevel	-305			; Suppress message 305

list	p=12f683
#include  <p12f683.inc>

	CB = _INTRC_OSC_NOCLKOUT
	CB &= _WDT_OFF
	CB &= _PWRTE_OFF
	CB &= _MCLRE_OFF
	CB &= _BOD_OFF
	CB &= _CPD_OFF
	CB &= _CP_OFF

	__CONFIG CB

;---------------------------------------------------------------------------
; PIN Assign
;Pin5(GPO2,CCP1)		IR_OUT,PWM
;---------------------------------------------------------------------------
; Power On vector
;---------------------------------------------------------------------------
	org		h'0'
	goto	INIT


;----------------------------
; Initialize PIC12F683
;----------------------------
INIT

	movlw	B'00000111'
	movwf	CMCON0 			; CMCON = CM0/CM1/CM2 ON (COMPARATOR OFF)

	bsf		STATUS, RP0		; Bank 1

	movlw	b'01110001'		; INT OSC 8Mhz 
	movwf	OSCCON			;


	clrf	ANSEL

	movlw	b'11111011'		; GPIO2 as output
	movwf	TRISIO			; Port I/O Set

	movlw	B'00000000'		; All Pins Pull-up disabled 
	movwf	WPU				;


;/*
; * PWM Register Values
; * Oscillator Frequency Fosc = 8000000
; * Clock Frequency Fclk = 2000000
; * PWM Freq = 38000 desired...actual: 37736
; * Prescaler Value = 1
; * PR2 = 52
; * Maximum duty value = 211 
; * Requested Duty Value = 106
; * 
; * Code Provided AS IS....Use at your own risk!
;*/

;// be sure to set PWM port as output
	movlw	b'00110100'		;
	movwf	PR2

	bcf		STATUS, RP0		; Bank 0

	movlw	b'00011010'		;  // set duty MSB
	movwf	CCPR1L

	movlw	b'00101100'		; // duty lowest bits + PWM mode
	movwf	CCP1CON


	movlw	b'00000100'		; // prescaler + turn on TMR2;
	movwf	T2CON


;-----------------------------------
; Main Loop 
;-----------------------------------
MAIN_LOOP
	goto	MAIN_LOOP

END
