/******************************************
*  I2CʐMCu
*   I2CStart()
*   I2CStop()
*   I2COut()
*   I2CRcv()
******************************************/
#include <xc.h>
#include "i2c_lib1.h"

/*****************************
* X^[go
*****************************/
void I2CStart(void){
	/* SCL,SDA͏펞HighƂ@*/
	GPIObits.SDA = 0;			// SDA Low
	TRISIObits.TRISSDA = 0;		// SDAo
}
/*****************************
* Xgbvo 
*****************************/
void I2CStop(void){
	GPIObits.SCL = 0;			// SCL Low
	__delay_us(1);
	GPIObits.SDA = 0;			// SDA Low
	TRISIObits.TRISSDA = 0;		// o̓[hɖ߂@SDA =Low
	GPIObits.SCL = 1;			// SCLHigh
	__delay_us(1);
	GPIObits.SDA = 1;			// ォSDAHigh
	__delay_us(10);				// Ԋupx	
}
/*********************************
* I2C1oCgo
* X[uACK߂lƂ 
**********************************/
unsigned char I2COut(unsigned char data){
	int i;
	unsigned char BitPos, ACK;

	/* Data Out */
	TRISIObits.TRISSDA = 0;		// SDAo̓[h
	BitPos = 0x80;				// rbgʒul
	for(i=0; i<8; i++){			// 8rbgJԂ
		GPIObits.SCL = 0;		// SCL Low
		if((data & BitPos) != 0)// rbgo
			GPIObits.SDA = 1;	// SDA High
		else
			GPIObits.SDA = 0;	// SDA Low
		BitPos = BitPos >> 1;	// rbgʒuړ
		GPIObits.SCL = 1;		// SCL Highɖ߂
	}
	/* Ack `FbN */
	GPIObits.SCL = 0;			// NbNPLow
	TRISIObits.TRISSDA = 1;		// ̓[hɂACK
	__delay_us(2);
	GPIObits.SCL = 1;			// NbNHighɖ߂
	__delay_us(2);
	ACK = GPIObits.SDA;			// ACK`FbN
	return(ACK);				// ACK߂lƂ
}
/********************************
* I2C1oCg
* p[^ACK/NAKԑ
********************************/
unsigned char I2CRcv(unsigned char Ack){
	int	i;
	unsigned char BitPos, data;

	data = 0;
	BitPos =0x80;				// rbgʒuZbg
	for(i=0; i<8; i++){			// 8rbgJԂ
		GPIObits.SCL = 0;		// SCL Low
		TRISIObits.TRISSDA = 1;	// ̓[h
		__delay_us(3);			// m
		GPIObits.SCL = 1;		// SCL High
		if(GPIObits.SDA)		// rbg
			data |= BitPos;
		BitPos = BitPos >> 1;	// rbgVtg
	}
	/* ACK/NAKo */
	GPIObits.SCL = 0;			// SCL Low
	GPIObits.SDA = Ack;			// ACK ot NAK o
	TRISIObits.TRISSDA = 0;		// SDAo̓[h
	__delay_us(2);				// pXm
	GPIObits.SCL = 1;			// SCL High
	return(data);				// Mf[^߂
}
