/***********************************************
*  t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
*
* ̃t@ĆA{Iɂ͌Ղ̃Cu( http://www.picfun.com/8pinPIC/8pinbookframe.html )x[X
* ꕔAiwamotõ\[X( http://sky.geocities.jp/home_iwamoto/page/P14K50/P14_B02.htm )
* }[WĂB
* 
**********************************************/
#include <xc.h>
#include "lcd_i2c_lib.h"
#include "i2c_lib1.h"

/*********************************
* t1\f[^o
*********************************/
void lcd_data(unsigned char data)
{
	I2CStart();					// X^[g
	I2COut(0x7C);					// AhX
	I2COut(0x40);					// \f[^w
	I2COut(data);					// \f[^o
	I2CStop();					// Xgbv
	__delay_us(50);				// x
}

/*******************************
* tւPR}ho 
*******************************/
void lcd_cmd(unsigned char cmd)
{
	I2CStart();					// X^[g
	I2COut(0x7C);					// AhX
	I2COut(0x00);					// R}hw
	I2COut(cmd);					// R}ho
	I2CStop();					// Xgbv
	if(cmd & 0xFC)   // ʂUrbgɂP閽
		__delay_us(50);  // 50usec
	else
		__delay_ms(2);   // 2msec@ClearHomeR}h
}
/*******************************
*  ֐ 
*******************************/
void lcd_init(void)
{
	__delay_ms(100);
	lcd_cmd(0x38);		// 8bit 2s \߃[h
	lcd_cmd(0x39);		// 8bit 2s g߃[h
	lcd_cmd(0x14);		// OSC  BIAS ݒ1/5
						// RgXgݒ 
	lcd_cmd(0x70 + (CONTRAST & 0x0F));
	lcd_cmd(0x54 + (CONTRAST >> 4));

//	lcd_cmd(0x79);
//	lcd_cmd(0x54);

	lcd_cmd(0x6B);		// Ffollwer
	__delay_ms(100);
	__delay_ms(100);
	lcd_cmd(0x38);		// \߃[h 
	lcd_cmd(0x0C);		// Display On 
	lcd_cmd(0x01);		// Clear Display 
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
	lcd_cmd(0x01);				//R}ho
}
/******************************
* J[\ʒuw
******************************/
void lcd_posyx(char ypos, char xpos){
	unsigned char pcode;
	switch(ypos & 0x03){	
		case 0:	pcode=0x80;break;
		case 1:	pcode=0xC0;break;
		case 2:	pcode=0x94;break;
		case 3:	pcode=0xD4;break;
	}
	lcd_cmd(pcode += xpos);
}
/*****************************
* \֐
*****************************/
void lcd_str(const unsigned char* ptr)
{
	while(*ptr != 0)				//o 
		lcd_data(*ptr++);			//\
}
/*****************************
*  ACR\֐
*****************************/
/*
void lcd_icon(unsigned char num, unsigned char onoff)
{
	lcd_cmd(0x39);				// Extend mode
	lcd_cmd(0x40 | ICON[num][0]);	// ACRAhXw
	if(onoff)
		lcd_data(ICON[num][1]);	// ACRIf[^
	else
		lcd_data(0x00);			// ACRItf[^
	lcd_cmd(0x38);				// Normal Mode
}
*/

/******************************
*  100msecx֐
******************************/
void delay_100ms(unsigned int time)
{
	time *= 4;					// 4{
	while(time){
		__delay_ms(25);			// 25msec
		time--;					// 100msec x time
	}
}
